Subject: [Asdf] asdf call at ietf109 20201117: Follow-up on ONF work

From: "Davis, Nigel" <[email-masked]>
Date: Wed, 18 Nov 2020 09:41:24 +0000

Hi,

On the call earlier yesterday I committed to provide you with links to the ONF work that I highlighted as related to your work. The links are all public and the work is open.

The key similarities are:

  *   Separation of semantic model (protocol neutral) from implementation model (protocol specific)
  *   Use of tooling to generate various implementation encodings from the models
  *   Modeling things 😊

Providing a little more detail on the ONF work

  *   The focus is networking and control of devices. Two projects:
     *   OTCC: https://wiki.opennetworking.org/display/OTCC/Open+Transport+Configuration+and+Control+Home
     *   OIMT: https://wiki.opennetworking.org/display/OIMT/OIMT
  *   UML is used for our protocol neutral modeling

  *   There are two distinct UML models
     *   A general model (Core IM (under OIMT))
        *   ONF Publication (including UML model (developed using Papyrus (https://www.eclipse.org/papyrus/ - free opensource tooling)) and explanatory material): https://opennetworking.org/wp-content/uploads/2018/12/TR-512_v1.4_OnfCoreIm-info.zip
        *   Wiki (presentations etc):  https://wiki.opennetworking.org/display/OIMT/Core+Model
        *   Github: https://github.com/OpenNetworkingFoundation/CoreInfoModel (note that we are still in the process of transferring our model work into the open repository from a private git repository)
        *   In the OIMT work we have been uncovering and developing patterns as we develop the model (e.g., component-port and component-system)
     *   An interface focused model (TAPI (under OTCC))
        *   GitHub (UML, Yang, OAS): https://github.com/OpenNetworkingFoundation/TAPI
        *   Wiki: https://wiki.opennetworking.org/display/OTCC/TAPI
        *   TAPI is being deployed in production systems in many operator networks
  *   TAPI is “pruned and refactored” from the Core IM
     *   This is where the meshy forest of DDD Aggregate-like trees are turned into the Yang tree hierarchy
  *   The Yang form of TAPI is derived from UML using tooling
     *   Github: https://github.com/OpenNetworkingFoundation/EagleUmlYang/tree/ToolChain
     *   Publications: Various under https://opennetworking.org/software-defined-standards/models-apis/ (PROJECT: INFORMATION MODELING)
     *   Wiki: https://wiki.opennetworking.org/display/OIMT/IISOMI
     *   We have a challenge getting resources to work on the tooling
  *   The implementation form of TAPI is in JSON
     *   The OAS is generated using tooling

I have copied my co-lead in OIMT and the leader of TAPI work.

Regards

Nigel